#include <fstream>
#include <iostream>
//#include "server_socket.h"
#include <sys/socket.h>
#include <vector>
#include <string>
#include <sstream>
#include <cstring>

extern "C" {
#include "stava.h"
#include "stavaapi.h"
#include "suffix.h"
}
// extern "C" {

//   //#include "stava.h"
// #include "stavaapi.h"
//   //#include "suffix.h"
// }

// #define LIBPATH "/misc/tcs/language/lib/"
// #define LIBPATH "/opt/stava/GPLstava_extra/lib/"
#define LIBPATH "/home/jsh/servergranskafiles/stava/GPLstava_extra/lib/"

#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netdb.h>
#include <strings.h>

inline int my_tolower(const int i) {
  if(i >= 'a' && i <= 'z')
    return i;
  if(i >= 'A' && i <= 'Z')
    return i - 'A' + 'a';
  if(i == '')
    return '';
  if(i == '')
    return '';
  if(i == '')
    return '';
  else return i;
}

#include <ext/hash_map>
namespace __gnu_cxx {
  template<> struct hash< std::string > {
    size_t operator()( const std::string& x ) const {
      return hash< const char* >()( x.c_str() );
    }
  };
}
typedef __gnu_cxx::hash_map<std::string, int, __gnu_cxx::hash<std::string> > map_string_int;
typedef __gnu_cxx::hash_map<int, int, __gnu_cxx::hash<int> > map_int_int;

map_string_int word_lex;
map_string_int pos_lex;
map_string_int chunk_lex;
map_string_int err_lex;

std::vector<std::string> original_text;
std::vector<std::string> inv_err_lex;

int add_or_look_up(map_string_int &lex, std::string str) {
  map_string_int::iterator it = lex.find(str);
  if(it == lex.end()) {
    if(&lex == &err_lex) {
      int res = inv_err_lex.size();
      lex[str] = res;
      inv_err_lex.push_back(str);
      return res;
    } else {
      int res = lex.size();
      lex[str] = res;
      return res;
    }
  } else {
    return it->second;
  }
}

int look_up(map_string_int &lex, std::string str) {
  map_string_int::iterator it = lex.find(str);
  if(it == lex.end()) {
    return -1;
  } else {
    return it->second;
  }
}

typedef int wordtype;
typedef int postype;
typedef int chunktype;
typedef int errtype;

struct rule {
  std::vector<std::pair<int, wordtype> > word_constraints;
  std::vector<std::pair<int, postype> > pos_constraints;
  std::vector<std::pair<int, chunktype> > chunk_constraints;
  std::vector<std::pair<int, errtype> > err_constraints;
  errtype newvalue;
  /*  
  void print(std::ostream &o) {
    o << newvalue << " IF ";
    for(int i = 0; i < word_constraints.size(); i++)
      o << "word " << word_constraints[i].first << " == " << word_constraints[i].second << ";";
    for(int i = 0; i < pos_constraints.size(); i++)
      o << "pos " << pos_constraints[i].first << " == " << pos_constraints[i].second << ";";
    for(int i = 0; i < chunk_constraints.size(); i++)
      o << "chunk " << chunk_constraints[i].first << " == " << chunk_constraints[i].second << ";";
    for(int i = 0; i < err_constraints.size(); i++)
      o << "err " << err_constraints[i].first << " == " << err_constraints[i].second << ";";
    o << "\n";
  }
  */
};

// fill vector with rules from stream, returns
// maximum offset used in ruleset
int read_rules(std::istream &in, std::vector<rule> &rules) {
  int max_forward_offset = 0;
  int max_backward_offset = 0;
  std::string line;
  std::getline(in, line);
  while(in) {
    if(line[0] != '#') {
      int pos = line.find("RULE:") + 6;
      int end = line.find("=>");
      rule r;
      while(pos < end) {
	int pos2 = line.find("_", pos);
	std::string column = line.substr(pos, pos2-pos);
	
	int offset = atoi(line.c_str() + pos2 + 1);
	if(offset > max_forward_offset)
	  max_forward_offset = offset;
	if(offset < max_backward_offset)
	  max_backward_offset = offset;

	int pos3 = line.find("=", pos2);
	int pos4 = line.find(" ", pos3);
	std::string value = line.substr(pos3+1, pos4-pos3-1);
	if(column == "word") {
	  r.word_constraints.push_back(std::pair<int, wordtype>(offset, add_or_look_up(word_lex,value)));
	}
	else if(column == "pos") {
	  r.pos_constraints.push_back(std::pair<int, postype>(offset, add_or_look_up(pos_lex,value)));
	}
	else if(column == "cmp") {
	  r.err_constraints.push_back(std::pair<int, errtype>(offset, add_or_look_up(err_lex,value)));
	}
	else if(column == "chunk"){
	  r.chunk_constraints.push_back(std::pair<int, chunktype>(offset, add_or_look_up(chunk_lex,value)));
	}
	pos = pos4 + 1;
      }
      pos = line.find("=", end+3);
      r.newvalue = add_or_look_up(err_lex,line.substr(pos+1));
      rules.push_back(r);
    }
    std::getline(in, line);
  }
  if(max_forward_offset > -max_backward_offset)
    return max_forward_offset;
  else
    return - max_backward_offset;
}

void slow_apply(rule &r, 
		std::vector<wordtype> &words,
		std::vector<postype> &poss,
		std::vector<errtype> &errs,
		std::vector<chunktype> &chunks
		) {
  int ZZZ = look_up(word_lex,"ZZZ");
  for(int i = 0; i < words.size(); i++) {
    if(words[i] != ZZZ) {
      int applies = 1;
      for(int j = 0; j < r.word_constraints.size(); j++)
	if(i + r.word_constraints[j].first < 0 
	   || i + r.word_constraints[j].first >= words.size()
	   || words[i + r.word_constraints[j].first] != r.word_constraints[j].second) {
	  applies = 0;
	  break;
	}
      for(int j = 0; applies && j < r.pos_constraints.size(); j++)
	if(i + r.pos_constraints[j].first < 0 
	   || i + r.pos_constraints[j].first >= poss.size()
	   || poss[i + r.pos_constraints[j].first] != r.pos_constraints[j].second) {
	  applies = 0;
	  break;
	}
      for(int j = 0; applies && j < r.chunk_constraints.size(); j++)
	if(i + r.chunk_constraints[j].first < 0 
	   || i + r.chunk_constraints[j].first >= chunks.size()
	   || chunks[i + r.chunk_constraints[j].first] != r.chunk_constraints[j].second) {
	  applies = 0;
	  break;
	}
      for(int j = 0; applies && j < r.err_constraints.size(); j++)
	if(i + r.err_constraints[j].first < 0 
	   || i + r.err_constraints[j].first >= errs.size()
	   || errs[i + r.err_constraints[j].first] != r.err_constraints[j].second) {
	  applies = 0;
	  break;
	}
      if(applies)
	errs[i] = r.newvalue;
    }
  }
}

void read_data(int socket,
	       std::vector<wordtype> &words,
	       std::vector<postype> &poss,
	       std::vector<errtype> &errs,
	       std::vector<chunktype> &chunks,
	       int max_offset
	       ) {
  char buf[10000+1];
  buf[0] = 0;
  bool done = 0;
  std::string text = "";

  while(!done) {
    int len = 0, offs = 0;
    while(offs < 10000 && !done) {
      len = read(socket, buf+offs, 10000 - offs);
      if(len > 0) {
	buf[10000] = 0;
	char *end = strstr(buf, "ENDQ");
	if(end) {
	  *end = 0;
	  done = 1;
	} else {
	  offs += len;
	}
      } else {
	buf[offs] = 0;
	done = 1;
      }
    }
    text += buf;
    int tl = text.length() - 10;
    if(tl < 0)
      tl = 0;
    if(text.substr(tl).find("ENDQ") != std::string::npos) {
      done = 1;
    }
  }
  std::istringstream in(text);

  std::string line;

  int MAD = add_or_look_up(pos_lex, "mad");

  for(int i = 0; i < max_offset; i++) {
    words.push_back(add_or_look_up(word_lex,"ZZZ"));
    original_text.push_back("ZZZ");
    poss.push_back(look_up(pos_lex,"ZZZ"));
    chunks.push_back(look_up(chunk_lex,"ZZZ"));
    errs.push_back(add_or_look_up(err_lex,"ZZZ"));
  }

  while(in && line.substr(0,4) != "ENDQ") {
    std::getline(in, line);
    if(line != "" && line.substr(0,4) != "ENDQ") {
      int pos = line.find_first_of(" \t");
      words.push_back(look_up(word_lex,line.substr(0,pos)));
      original_text.push_back(line.substr(0,pos));
      //std::cerr << "found word '" << words[words.size()-1] << "' '" << line.substr(0,pos) << "'\n";
      int pos2 = line.find_first_of(" \t\n\r", pos+1);
      if(pos2 == std::string::npos) {
	poss.push_back(add_or_look_up(pos_lex,line.substr(pos+1)));
	pos2 = line.length();
      } else
	poss.push_back(add_or_look_up(pos_lex,line.substr(pos+1,pos2-pos-1)));
      //std::cerr << "found pos '" << poss[poss.size()-1] << "' '" << line.substr(pos+1,pos2-pos-1) << "'\n";
      int pos3 = line.find_first_of(" \t", pos2+1);
      if(pos3 != std::string::npos) {
	chunks.push_back(look_up(chunk_lex,line.substr(pos2+1,pos3-pos2-1)));
	//std::cerr << "found chunk '" << chunks[chunks.size()-1] << "'\n";
	pos2 = pos3;
      }
      pos3 = line.find_first_of(" \t\r\n", pos2+1);
      if(pos3 != std::string::npos) {
	// if there is no column with this data, pos2 is 
	// normaly line.length() so we get errs[i] = "", 
	// which is fine
	errs.push_back(add_or_look_up(err_lex,line.substr(pos2+1, pos3-pos2-1)));
      } else if(pos2 + 1 < line.length()) {
	errs.push_back(add_or_look_up(err_lex,line.substr(pos2+1)));
      } else {
	errs.push_back(add_or_look_up(err_lex,""));
      }
      //std::cerr << "found err '" << errs[errs.size()-1] << "'\n";
      if(poss[poss.size()-1] == MAD) {
	for(int i = 0; i < max_offset; i++) {
	  words.push_back(add_or_look_up(word_lex,"ZZZ"));
	  original_text.push_back("ZZZ");
	  poss.push_back(look_up(pos_lex,"ZZZ"));
	  chunks.push_back(look_up(chunk_lex,"ZZZ"));
	  errs.push_back(add_or_look_up(err_lex,"ZZZ"));
	}
      }
    }
  }
  
  for(int i = 0; i < max_offset; i++) {
    words.push_back(add_or_look_up(word_lex,"ZZZ"));
    original_text.push_back("ZZZ");
    poss.push_back(look_up(pos_lex,"ZZZ"));
    chunks.push_back(look_up(chunk_lex,"ZZZ"));
    errs.push_back(add_or_look_up(err_lex,"ZZZ"));
  }
}

void read_initial_guess_lexicon(std::istream &in, map_int_int &init_lex) {
  std::string line;
  while(in) {
    std::getline(in, line);
    if(line.length() > 1) {
      int pos = line.find_first_of(" \t");
      int pos2 = line.find_first_of(" \t\r\n", pos+1);
      int word = add_or_look_up(word_lex,line.substr(0,pos));
      int val;
      if(pos2 != std::string::npos)
	val = add_or_look_up(err_lex,line.substr(pos+1,pos2-pos-1));
      else
	val = add_or_look_up(err_lex,line.substr(pos+1));
      init_lex[word] = val;
    }
  }
}

void initial_guess(
		   std::vector<wordtype> &words,
		   std::vector<postype> &poss,
		   std::vector<errtype> &errs,
		   std::vector<chunktype> &chunks,
		   map_int_int &init_lex
		   ) {
  int ZZZ = look_up(word_lex,"ZZZ");
  for(int i = 0; i < words.size(); i++) {
    if(words[i] != ZZZ) {
      map_int_int::iterator it = init_lex.find(words[i]);
      if(it != init_lex.end())
	errs[i] = it->second;
      else
	errs[i] = add_or_look_up(err_lex,"OK");
      //      if(errs[i] != add_or_look_up(err_lex,"OK"))
      //	std::cerr << "init guess:" << original_text[i] << " " << inv_err_lex[errs[i]] << "\n";
    }
  }
}


void filter_with_stava(
		       std::vector<wordtype> &words,
		       std::vector<postype> &poss,
		       std::vector<errtype> &errs,
		       std::vector<chunktype> &chunks
		       ) {
  int OK = add_or_look_up(err_lex, "OK");
  int ZZZ = add_or_look_up(err_lex, "ZZZ");
  int PMNOM = add_or_look_up(pos_lex, "pm.nom");
  int PMGEN = add_or_look_up(pos_lex, "pm.gen");
  
  for(int i = 0; i < words.size(); i++) {
    if(errs[i] != OK && errs[i] != ZZZ) {
      unsigned char temp[1000];
      bool compound = 0, nonalpha = 0;

      std::string word = original_text[i];
      std::transform(word.begin(), word.end(),word.begin(), my_tolower);
      
      for(int j = 0; !nonalpha && j < word.size(); j++)
	if(!((word[j] >= 'a' && 
	      word[j] <= 'z') 
	     || word[j] == '' 
	     || word[j] == '' 
	     || word[j] == '' 
	     || word[j] == '' 
	     || word[j] == '-'
	     )) {
	  nonalpha = 1;
	}
      if(nonalpha) {
	errs[i] = OK;
      } else {
	for(int k = 0; !compound && i+k >=0 && errs[i+k] != ZZZ && errs[i+k] != OK; k--) {
	  std::string word = original_text[i+k];
	  std::string worda = original_text[i+k] + "s";
	  std::string wordb;
	  std::string wordc = original_text[i+k] + "s";
	  for(int j=k+1; j <= 0; j++) {
	    wordb = word + "s" + original_text[i+j];
	    wordc += "s";
	    wordc += original_text[i+j];
	    if(word.length() > 2 
	       &&
	       word[word.length()-1] == original_text[i+j][0]
	       &&
	       word[word.length()-1] == word[word.length()-2]
	       ) {
	      word += original_text[i+j].substr(1);
	      worda += original_text[i+j].substr(1);
	    }
	    else {
	      word += original_text[i+j];
	      worda += original_text[i+j];
	    }
	  }
	  if(k != 0) {
	    if(StavaAnalyzeCompound(temp,
				    (const unsigned char *) (word.c_str()))) {
	      compound = 1;
	    }
	    if(StavaAnalyzeCompound(temp,
				    (const unsigned char *) (worda.c_str()))) {
	      compound = 1;
	    }
	    if(StavaAnalyzeCompound(temp,
				    (const unsigned char *) (wordb.c_str()))) {
	      compound = 1;
	    }
	    if(StavaAnalyzeCompound(temp,
				    (const unsigned char *) (wordc.c_str()))) {
	      compound = 1;
	    }
	  }
	  for(int j = 1; !compound && i+j < words.size() && errs[i+j] != ZZZ && errs[i+j] != OK; j++) {
	    wordb = word + "s" + original_text[i+j];
	    wordc += "s";
	    wordc += original_text[i+j];
	    if(word.length() > 2 
	       &&
	       word[word.length()-1] == original_text[i+j][0]
	       &&
	       word[word.length()-1] == word[word.length()-2]
	       ) {
	      word += original_text[i+j].substr(1);
	      worda += original_text[i+j].substr(1);
	    }
	    else {
	      word += original_text[i+j];
	      worda += original_text[i+j];
	    }
	    if(StavaAnalyzeCompound(temp,
				    (const unsigned char *) (word.c_str()))) {
	      compound = 1;
	    }
	    if(StavaAnalyzeCompound(temp,
				    (const unsigned char *) (worda.c_str()))) {
	      compound = 1;
	    }
	    if(StavaAnalyzeCompound(temp,
				    (const unsigned char *) (wordb.c_str()))) {
	      compound = 1;
	    }
	    if(StavaAnalyzeCompound(temp,
				    (const unsigned char *) (wordc.c_str()))) {
	      compound = 1;
	    }
	  }
	}
      }
      /* ALLOW PM.* TO BE HEADS EVEN IF STAVA DISAGREES ***********************************************/
      if((poss[i-1] == PMNOM || poss[i-1] == PMGEN)
	 && errs[i-1] != ZZZ && errs[i-1] != OK) {
	compound = 1;
      }
      if((poss[i] == PMNOM || poss[i] == PMGEN)
	 && errs[i+1] != ZZZ && errs[i+1] != OK) {
	compound = 1;
      }
      if(!compound) {
	errs[i] = OK;
      }
    }    
  }
}

// taken from a socket primer
int establish(int portnum)
{ 
  const int MAXHOSTNAME = 1000;
  char myname[MAXHOSTNAME+1];
  int s;
  struct sockaddr_in sa;
  struct hostent *hp;
  
  bzero(&sa,sizeof(struct sockaddr_in));
  gethostname(myname,MAXHOSTNAME);
  hp= gethostbyname(myname);
  if (hp == NULL)
    return -1;
  sa.sin_family= hp->h_addrtype; /* this is our host address */
  sa.sin_port= htons(portnum); /* this is our port number */
  if ((s = socket(AF_INET,SOCK_STREAM,0)) < 0)
    return -1;
  if (bind(s,(struct sockaddr *)&sa,sizeof(sa)) < 0) {
    close(s);
    return -1;
  }
  listen(s, 5); /* max # of queued connects */
  return s;
}

// taken from a socket primer
int get_connection(int s // socket
		   )
{ 
  struct sockaddr_in isa;
  socklen_t i;
  int t;
  
  i = sizeof(isa);
  getsockname(s,(struct sockaddr *)&isa,&i);
  
  if ((t = accept(s,(struct sockaddr *)&isa,&i)) < 0)   /* accept connection if there is one */
    return -1;
  return t;
}
	       
int main(int argc, char **argv) {

  if(argc < 4) {
    std::cerr << argv[0] << " rule-file port initial-guess-lexicon" << std::endl;
    return 0;
  }

  if (!StavaReadLexicon(LIBPATH,1,1,0,0,0,0,(const unsigned char *)",")) {
    fprintf(stderr, "Kan inte initiera Stava\n");
    exit(1);
  }

  /* handler for child processes */
  signal(SIGCLD, SIG_IGN);

  std::vector<rule> rules;
  std::ifstream rulefile(argv[1]);
  int max_offset = read_rules(rulefile, rules);
  if(max_offset < 1)
    max_offset = 1;

  std::vector<wordtype> words;
  std::vector<postype> poss;
  std::vector<errtype> errs;
  std::vector<chunktype> chunks;
  
  std::ifstream guess_lex(argv[3]);
  map_int_int init_lex;
  read_initial_guess_lexicon(guess_lex, init_lex);

  int portno = atoi(argv[2]);
  int server_socket;
  if ((server_socket = establish(portno)) < 0) {  /* plug in the phone */
    std::cerr << "could not open socket for listening\n";
    exit(1);
  }

  while(1) {
    std::cerr << "waiting...\n";
    words.clear();
    poss.clear();
    errs.clear();
    chunks.clear();
    original_text.clear();

    int client_socket = 0;

    if ((client_socket = get_connection(server_socket)) < 0) {
      if (errno == EINTR)
	continue;
      std::cerr << "error on accept\n";
      exit(1);
    }
    
    // fork all client calls, that way, if they hang or crash,
    // the server keeps working
    std::ostringstream buf;
    switch(fork()) {
    case -1 : // error
      std::cerr << "error on fork()\n";
      exit(1);
    case 0 : // child
      close(server_socket);
      alarm(60*2); // if we still haven't finished in 2 minutes, die...
      read_data(client_socket,
		words,
		poss,
		errs,
		chunks,
		max_offset
		);
      alarm(0); // remove alarm
      initial_guess(
		    words,
		    poss,
		    errs,
		    chunks,
		    init_lex
		    );
      
      for(int i = 0; i < rules.size(); i++)
	slow_apply(rules[i], 
		   words,
		   poss,
		   errs,
		   chunks
		   );
      filter_with_stava(
			words,
			poss,
			errs,
			chunks
			);
      
      buf << "<reply>\n";
      for(int i = 0; i < words.size(); i++)
	if(words[i] != look_up(word_lex,"ZZZ"))
	  buf << original_text[i] << "\t" << inv_err_lex[errs[i]] << "\n";
      buf << "</reply>\n";
      write(client_socket, buf.str().c_str(), buf.str().length() * sizeof(char));
      
      close(client_socket);
      exit(0); // child is finished      
    default : // parent
      close(client_socket);
    }
  }
  return 0;
}
